#include "datum.h"
#include <iomanip.h>

//------------------------------------------------------------
// Constructor
//------------------------------------------------------------
date::date (int t, int m, int j, int f)
{
   Day   = t;
   Month = m;
   Year  = j;
   Formated = f;
   check ();
}

//------------------------------------------------------------
// Operator: Addition mit einem Integer
//------------------------------------------------------------
date date::operator+ (int y)
{
   date Result;

   Result.Day   = Day;
   Result.Month = Month;
   Result.Year  = Year + y;
   return (Result);
}

//------------------------------------------------------------
// Operator: Postincrement
//------------------------------------------------------------
date date::operator++ (void)
{
   Year++;
   return (*this);
}

//------------------------------------------------------------
// Friend Operator: Addition mit einem Integer
//------------------------------------------------------------
int operator+ (int & a, date d)
{
   return (a + d.Year);
}

//------------------------------------------------------------
// Friend Operator: Stream-Output
//------------------------------------------------------------
ostream & operator<< (ostream & s, date d)
{
   int oldfill;
   if (!d.Formated)
      return (s << d.Day << "." << d.Month << "." << d.Year);

   oldfill = s.fill ('0');
   s << setw(2) << d.Day << "." << setw (2) << d.Month
     << "." << d.Year;
   s.fill (oldfill);
   return (s);
}

//------------------------------------------------------------
// Datum prfen
//------------------------------------------------------------
void date::check (void)
{
   if (Month > 12) Month = 12;   // max. Dezember
   if (Month < 1)  Month = 1;    // min. Januar
   if (Year > 3000) Year = 3000; // max. bis Jahr 3000
   if (Year < 1800) Year = 1800; // min. Jahr 1800
   if (Day < 1) Day = 1;         // min. Monatserster
   switch (Month)
   {
      case 2 : // Februar - es gilt immer:
               if (Day > 29) Day = 29;
               // fr Nicht-Schaltjahre gilt immer:
               if (Year % 4) { if (Day > 28) Day= 28;}
               else
                  // durch 100 teilb.? kein Schaltj.
                  // durch 400 teilbar? doch nicht
                  if ((!(Year % 100))&&(Year % 400))
                     if (Day > 28) Day = 28;
               break;
      case 4 :
      case 6 :
      case 9 :
      case 11: if (Day > 30) Day = 30;
               break;   
      default: if (Day > 31) Day = 31;
               break;   
   }
}

