#include <excpt.h>
#include <iostream.h>
#include <stdlib.h>

//------------------------------------------------------------------------------
// Funktion mit Exceptionhandling
//------------------------------------------------------------------------------
double fnFakultaet (int Param)
{
   double Ergebnis = 1.0;

   //---------------------------------------------------------------------------
   // Fakultt von negativen Werten ist nicht definiert: Exception auslsen
   //---------------------------------------------------------------------------
   if (Param < 0) throw 1;

  	if (0 == Param) Param = 1;
   for (int i=Param; i>1; i--) Ergebnis *= i;

   return Ergebnis;
}

//------------------------------------------------------------------------------
// Testprogramm
//------------------------------------------------------------------------------
void main (void)
{
   char sEingabe [80];
   int fak = 0;

   cout << "Parameter : ";
   cin.getline (sEingabe, 80);
   fak = atoi (sEingabe);

   //---------------------------------------------------------------------------
   // Die folgenden Codezeilen berwachen (try-Block)
   //---------------------------------------------------------------------------
   try
   {
      //------------------------------------------------------------------------
      // Die Exception kann hier ODER in einer Unterfunktion ausgelst werden
      //------------------------------------------------------------------------
      if (fak > 50) throw 1;
      cout << fnFakultaet (fak) << endl;
   }
   //---------------------------------------------------------------------------
   // Exceptionhandler, wird aufgerufen, wenn im try-Block eine Exception
   // ausgelst wird
	// catch (...) ist der Handler fr jede beliebige C++ Exception
   //---------------------------------------------------------------------------
   catch ( ... )
   {
      cout << "Es wurde eine Exception ausgelst";
   }

   cout << endl << "Programmende" << endl;
}

