#include <excpt.h>
#include <except.h>
#include <iostream.h>
#include <stdlib.h>

//------------------------------------------------------------------------------
// Fakultts-Fehler-Objekt
//------------------------------------------------------------------------------
class FakulError
{
   protected:
      int error;

   public:
      FakulError (int i = 0) {error = i;}
      void GetError (void);
};

//------------------------------------------------------------------------------
// Fakultts-Fehlermethode
//------------------------------------------------------------------------------
void FakulError::GetError (void)
{
	cout << "Fakultt: ";
	switch (error)
   {
   	case 1 : cout << "negativer Wert";
               break;
   	case 2 : cout << "Parameter zu gro";
               break;
      default: cout << "unbekannter Fehler";
               break;
   }
}

//------------------------------------------------------------------------------
// Eigene terminate-function
//------------------------------------------------------------------------------
void myTerminate ()
{
	cout << "myTerminate";
   abort();
}

//------------------------------------------------------------------------------
// Eigene unexpected-function
//------------------------------------------------------------------------------
void myUnexpected ()
{
	cout << "unerwartete Exception";
   abort();
}

//------------------------------------------------------------------------------
// Funktion mit Exceptionhandling
//------------------------------------------------------------------------------
double fnFakultaet (int Param) throw (FakulError, int)
{
   double Ergebnis = 1.0;

   //---------------------------------------------------------------------------
   // Exception auslsen
   //---------------------------------------------------------------------------
   if (Param > 200) throw "P";   // lst unexpected Exception aus
   if (Param > 100) throw 100;
   if (Param > 50)  throw FakulError(2);
   if (Param < 0)   throw FakulError(1);

  	if (0 == Param) Param = 1;
   for (int i=Param; i>1; i--) Ergebnis *= i;

   return Ergebnis;
}

//------------------------------------------------------------------------------
// Testprogramm
//------------------------------------------------------------------------------
void main (void)
{
   char sEingabe [80];
   int fak = 0;

   //---------------------------------------------------------------------------
   // Eigene Termination und Unexpected
   //---------------------------------------------------------------------------
	terminate_function  OldTerminate  = set_terminate  (myTerminate);
   unexpected_function OldUnexpected = set_unexpected (myUnexpected);

   cout << "Parameter : ";
   cin.getline (sEingabe, 80);
   fak = atoi (sEingabe);

   //---------------------------------------------------------------------------
   // Die folgenden Codezeilen berwachen (try-Block)
   //---------------------------------------------------------------------------
   try
   {
      cout << fnFakultaet (fak) << endl;
   }
   //---------------------------------------------------------------------------
   // Exceptionhandler, wird aufgerufen, wenn im try-Block eine Exception
   // ausgelst wird
   //---------------------------------------------------------------------------
   catch (FakulError& x)
   {
      x.GetError();
   }
   catch (int x)
   {
      cout << "integer Exception";
   }

   cout << endl << "Programmende" << endl;
  	set_terminate  (OldTerminate);
	set_unexpected (OldUnexpected);
}

